int state = 0;
int score =0;

//Images
PImage menu;
PImage trashImg;
PImage gameboard; 
PImage whale;
PImage whaleleft;
PImage corals;
PImage shipwreck;
PImage tanker;
PImage jellyfish;
//whale variabler
float xwhale =200;
float ywhale =400;
float bwhale = 500;
float hwhale = 400;
float xwhalespeed = 0;
float ywhalespeed = 0;
int lookdirection =0;
//arraylists
ArrayList <Bubble> bubbleList;
Bubble bubble1 = new Bubble(20, 20);
ArrayList <Trash> trashList;


//tanker variabel
int xtanker = 0;

void setup() {
    size(1400, 800);
    menu = loadImage("menu.jpg");
    gameboard = loadImage("gameboard.jpg");
    whale = loadImage("whale.png");
    corals = loadImage ("corals.png");
    shipwreck =loadImage("shipwreck.png");
    tanker = loadImage("tanker.png");
    jellyfish =loadImage ("jellyfish.png");
    whaleleft =loadImage("whaleleft.png");
    trashImg =loadImage("trash.png");
    bubbleList = new ArrayList <Bubble>();
    trashList = new ArrayList <Trash>();
}

void draw() {
    if (state == 0) // welcome state
    {
        welcomeMenu();
    } else if (state==1) // play the game state
    {
        gameScreen();
    } else if (state == 2) // gameover state -win
    {
        winScreen();
    } else if (state == 3) // gameover state -loose
    {
        looseScreen();
    }
}
void welcomeMenu() {
    image(menu, 0, 0, 1400, 800);
    textSize(50);
    text("Welcome to Battle Of The Oceans", width/2-400, height/2);
    textSize(20);
    text("Press LeftMouse to start", width/2-200, height/2+50);
    text("Move with arrow-keys & shoot space", width/2-200, height/2+100);
    text("Shoot the trash to stay alive as long as possible before it reaches the ocean floor", width/2-200, height/2+150);

    if (mousePressed) {
        state = 1;
    }
}
void gameScreen() {
    image(gameboard, 0, 0, 1400, 800);
    image (corals, 900, 600, 400, 200);
    image(shipwreck, 100, 600, 200, 200);
    image (tanker, xtanker, 100, 200, 200);
    image(jellyfish, 400, 400, 50, 50);
    image(jellyfish, 450, 450, 50, 50);
    image(jellyfish, 350, 450, 50, 50);

    //whalespeed
    ywhale = ywhale + ywhalespeed;
    xwhale = xwhale +xwhalespeed;
    //whale directional movement
    if (lookdirection == 0) {
        image(whaleleft, xwhale, ywhale, bwhale, hwhale);
    } else
    {
        if (lookdirection ==1)
            image(whale, xwhale, ywhale, bwhale, hwhale);
    }


    //border containment
    if (xwhale > width-100) {
        xwhale = 0-300;
    }
    if (xwhale < 0-300) {
        xwhale = 1400-100;
    }
    if (ywhale > height-250) {
        ywhale = height-250;
    }
    if (ywhale < 180) {
        ywhale = 180;
    }
    xtanker = xtanker +1;
    if (xtanker > 1400) {
        xtanker = -200;
    }
    //bubblesskyd
    for (int i=0; i<bubbleList.size(); i = i+1) {

        Bubble bubble = bubbleList.get(i);
        bubble.display();
        bubble.movement();
        if (bubble.OverSurface()) {
            bubbleList.remove(i);
        }
        for ( int j=trashList.size()-1; j >= 0; j=j-1) { //bubble & trash collision //tæller den anden vej i forhold til bubbleskyd
            Trash localtrash = trashList.get(j);
            if (localtrash.collideBubble(bubble)) {

                print("hit");
                score = score +1;
                if (score > 50) {
                    state = 2;
                }
                bubbleList.remove(i);
                trashList.remove(j);
            }
        }
    }
    //trash spawn
    for ( int j=0; j<trashList.size(); j= j+1) {
        Trash localtrash = trashList.get(j);
        localtrash.movement();
        localtrash.display();
        if (localtrash.OceanFloor()) {
            trashList.remove(j);
            score = score -1;
            if (score < -5) {
                state = 3;
            }
        }
    }
    if (random(0, 10)<0.25) {
        trashList.add( new Trash(random(0, width), 300));
    }
}
//whale movement
void keyPressed() {
    if (key == CODED) {
    }
    if (keyCode == UP) {
        ywhalespeed = -10;
    }
    if (keyCode == DOWN) {
        ywhalespeed =10;
    }
    if (keyCode == RIGHT) {
        lookdirection = 1;
        xwhalespeed = 10;
    }
    if (keyCode == LEFT) {
        lookdirection =0;
        xwhalespeed = -10;
    }
    if (key==' ') {
        bubbleList.add(new Bubble(xwhale+250, ywhale+150)); 
        println(bubbleList.size());
    }
}
void keyReleased() {

    if (key == CODED) {
        if (keyCode == UP || keyCode == DOWN) 

            ywhalespeed = 0;
    }
    if (keyCode == RIGHT || keyCode == LEFT) {
        xwhalespeed = 0;
    }
}
void winScreen() {
    background(0);
    textSize(40);
    text("You have saved the oceans -Hurray", width/2-400, height/2);
    if (mousePressed) {
        state =0;
        score = 0;
    }
}
void looseScreen() {
    background(0);
    textSize(40);
    text("The last living species in the ocean has perished", width/2-420, height/2);
    if (mousePressed) {
        state =0;
        score =0;
    }
}
